<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['management:aboutUs:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['management:aboutUs:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['management:aboutUs:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['management:aboutUs:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="aboutUsList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="关于我们id" align="center" prop="aboutUsId" />
      <el-table-column label="标题" align="center" prop="title" />
      <el-table-column label="求助电话" align="center" prop="helpPhone" />
      <el-table-column label="简介1" align="center" prop="briefText1" />
      <el-table-column label="简介2" align="center" prop="briefText2" />
      <el-table-column label="简介3" align="center" prop="briefText3" />
      <el-table-column label="简介4" align="center" prop="briefText4" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['management:aboutUs:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['management:aboutUs:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改关于我们对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="标题" prop="title">
          <el-input v-model="form.title" placeholder="请输入标题" />
        </el-form-item>
        <el-form-item label="求助电话" prop="helpPhone">
          <el-input v-model="form.helpPhone" placeholder="请输入求助电话" />
        </el-form-item>
        <el-form-item label="展示图片">
          <imageUpload v-model="form.showPictures"/>
        </el-form-item>
        <el-form-item label="简介1" prop="briefText1">
          <el-input v-model="form.briefText1" placeholder="请输入简介1" />
        </el-form-item>
        <el-form-item label="简介2" prop="briefText2">
          <el-input v-model="form.briefText2" placeholder="请输入简介2" />
        </el-form-item>
        <el-form-item label="简介3" prop="briefText3">
          <el-input v-model="form.briefText3" placeholder="请输入简介3" />
        </el-form-item>
        <el-form-item label="简介4" prop="briefText4">
          <el-input v-model="form.briefText4" placeholder="请输入简介4" />
        </el-form-item>
        <el-form-item label="详情">
          <editor v-model="form.content" :min-height="192"/>
        </el-form-item>
        <el-form-item label="背景图片1">
          <imageUpload v-model="form.bgImg1"/>
        </el-form-item>
        <el-form-item label="背景图片2">
          <imageUpload v-model="form.bgImg2"/>
        </el-form-item>
        <el-form-item label="背景图片3">
          <imageUpload v-model="form.bgImg3"/>
        </el-form-item>
        <el-form-item label="背景图片4">
          <imageUpload v-model="form.bgImg4"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listAboutUs, getAboutUs, delAboutUs, addAboutUs, updateAboutUs, exportAboutUs } from "@/api/management/aboutUs";

export default {
  name: "AboutUs",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 关于我们表格数据
      aboutUsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询关于我们列表 */
    getList() {
      this.loading = true;
      listAboutUs(this.queryParams).then(response => {
        this.aboutUsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        aboutUsId: null,
        title: null,
        helpPhone: null,
        showPictures: null,
        briefText1: null,
        briefText2: null,
        briefText3: null,
        briefText4: null,
        content: null,
        bgImg1: null,
        bgImg2: null,
        bgImg3: null,
        bgImg4: null,
        createTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.aboutUsId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加关于我们";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const aboutUsId = row.aboutUsId || this.ids
      getAboutUs(aboutUsId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改关于我们";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.aboutUsId != null) {
            updateAboutUs(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addAboutUs(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const aboutUsIds = row.aboutUsId || this.ids;
      this.$confirm('是否确认删除关于我们编号为"' + aboutUsIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delAboutUs(aboutUsIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有关于我们数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportAboutUs(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
